/*
 * ICESOFT COMMERCIAL SOURCE CODE LICENSE V 1.1
 *
 * The contents of this file are subject to the ICEsoft Commercial Source
 * Code License Agreement V1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of the
 * License at
 * http://www.icesoft.com/license/commercial-source-v1.1.html
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under
 * the License.
 *
 * Copyright 2009-2015 ICEsoft Technologies Canada, Corp. All Rights Reserved.
 */
package com.icesoft.faces.facelets.component;

import javax.el.ELException;
import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.view.facelets.FaceletContext;
import javax.faces.view.facelets.TagAttribute;
import javax.faces.view.facelets.TagConfig;
import javax.faces.view.facelets.TagHandler;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class RequiredAttributeHandler extends TagHandler implements Serializable {

    private final TagAttribute attrs;

    public RequiredAttributeHandler(TagConfig config) {
        super(config);

        this.attrs = this.getRequiredAttribute("attrs");

    }

    public void apply(FaceletContext ctx, UIComponent parent)
            throws IOException, FacesException, ELException {
        StringTokenizer tokens = new StringTokenizer(this.attrs.getValue(ctx), ",");
        List missingAttributes = new ArrayList();
        while (tokens.hasMoreTokens()) {
            String requiredAttr = tokens.nextToken();
            if (ctx.getVariableMapper().resolveVariable(requiredAttr) == null)
                missingAttributes.add(requiredAttr);
        }
        ctx.setAttribute("missingAttributes", missingAttributes);
        this.nextHandler.apply(ctx, parent);

    }

}
